/**
 * Orbipay-Checkout APIs
 * API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: checkout.orbipay@alacriti.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Address'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Address'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayCheckoutApIs) {
      root.OrbipayCheckoutApIs = {};
    }
    root.OrbipayCheckoutApIs.Payer = factory(root.OrbipayCheckoutApIs.ApiClient, root.OrbipayCheckoutApIs.Address);
  }
}(this, function(ApiClient, Address) {
  'use strict';




  /**
   * The Payer model module.
   * @module model/Payer
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>Payer</code>.
   * @alias module:model/Payer
   * @class
   * @param lastName {String} Payer's last name
   * @param email {String} Payer's email address
   */
  var exports = function(lastName, email) {
    var _this = this;




    _this['last_name'] = lastName;
    _this['email'] = email;


  };

  /**
   * Constructs a <code>Payer</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Payer} obj Optional instance to populate.
   * @return {module:model/Payer} The populated <code>Payer</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('customer_id')) {
        obj['customer_id'] = ApiClient.convertToType(data['customer_id'], 'String');
      }
      if (data.hasOwnProperty('first_name')) {
        obj['first_name'] = ApiClient.convertToType(data['first_name'], 'String');
      }
      if (data.hasOwnProperty('last_name')) {
        obj['last_name'] = ApiClient.convertToType(data['last_name'], 'String');
      }
      if (data.hasOwnProperty('middle_name')) {
        obj['middle_name'] = ApiClient.convertToType(data['middle_name'], 'String');
      }
      /*if (data.hasOwnProperty('date_of_birth')) {
        obj['date_of_birth'] = ApiClient.convertToType(data['date_of_birth'], 'String');
      }*/
      if (data.hasOwnProperty('ssn')) {
        obj['ssn'] = ApiClient.convertToType(data['ssn'], 'String');
      }
      if (data.hasOwnProperty('locale')) {
        obj['locale'] = ApiClient.convertToType(data['locale'], 'String');
      }
      if (data.hasOwnProperty('email')) {
        obj['email'] = ApiClient.convertToType(data['email'], 'String');
      }
      if (data.hasOwnProperty('phone_number')) {
        obj['phone_number'] = ApiClient.convertToType(data['phone_number'], 'String');
      }
      /*if (data.hasOwnProperty('home_phone')) {
        obj['home_phone'] = ApiClient.convertToType(data['home_phone'], 'String');
      }
      if (data.hasOwnProperty('work_phone')) {
        obj['work_phone'] = ApiClient.convertToType(data['work_phone'], 'String');
      }
      if (data.hasOwnProperty('mobile_phone')) {
        obj['mobile_phone'] = ApiClient.convertToType(data['mobile_phone'], 'String');
      }*/
      if (data.hasOwnProperty('address')) {
        obj['address'] = Address.constructFromObject(data['address']);
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
    
    }
    return obj;
  }

  /**
   * Id is a unique identifier with checkout for the customer.
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Payer Url.
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * Payer's customer reference
   * @member {String} customer_id
   */
  exports.prototype['customer_id'] = undefined;
  /**
   * Payer's first name
   * @member {String} first_name
   */
  exports.prototype['first_name'] = undefined;
  /**
   * Payer's last name
   * @member {String} last_name
   */
  exports.prototype['last_name'] = undefined;
    /**
   * Payer's middle name
   * @member {String} middle_name
   */
  exports.prototype['middle_name'] = undefined;
  /**
   * Payer's date_of_birth
   * @member {String} date_of_birth
   */
  //exports.prototype['date_of_birth'] = undefined;
  /**
   * Payer's ssn
   * @member {String} ssn
   */
  exports.prototype['ssn'] = undefined;
  /**
   * Payer's locale
   * @member {String} locale
   */
  exports.prototype['locale'] = undefined;
  /**
   * Payer's email address
   * @member {String} email
   */
  exports.prototype['email'] = undefined;
  /**
   * Payer's home phone
   * @member {String} home_phone
   */
  exports.prototype['phone_number'] = undefined;
  /**
   * Payer's home phone
   * @member {String} home_phone
   */
  //exports.prototype['home_phone'] = undefined;
  /**
   * Payer's work phone
   * @member {String} work_phone
   */
  //exports.prototype['work_phone'] = undefined;
  /**
   * Payer's mobile phone
   * @member {String} mobile_phone
   */
  //exports.prototype['mobile_phone'] = undefined;
  /**
   * @member {module:model/Address} address
   */
  exports.prototype['address'] = undefined;
  /**
   * @member {String} status
   */
  exports.prototype['status'] = undefined;


  return exports;
}));


